#ifndef __Base_h__
#define __Base_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>
#include <cadadata/Value.h>

#include <librfcdal/DalDatabase.h>

//#include <librfc/XMLNode.hpp>

namespace CADAData
{
	enum Mode{ modeMinimal, modeInterim, modeFull };
	enum Action{ actAdd, actEdit, actDel };

	class CADAData_Export Base
	{
		private:
			bool _bIsDirty;
			ValuePtrList _valueS;

		public:
			Base();
			Base( const Base& base );
			virtual ~Base();

			const Base& operator=( const Base& base );

			void addValue( StringValue& value );
			void addValue( IntValue& value );
			void addValue( DoubleValue& value );

			bool isDirty() const;

//			virtual void toXML( Rfc::XMLNode& nodeParent, Mode mode = modeFull ) const = 0;
//			virtual void toXHTML( Rfc::XMLNode& nodeParent, Mode mode = modeFull ) const = 0;

//			static Base fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db ) throw( Exception );
//			static Base fromXML( const XMLNode& node ) throw( Exception );

		protected:
			void setDirty( bool bIsDirty );
	};

	class CADAData_Export List
	{
		public:
			List();
			List( const List& list );
			virtual ~List();

			const List& operator=( const List& list );

			virtual void toXML( Rfc::XMLNode& nodeParent, Mode mode = modeFull ) const = 0;
			virtual void toXHTML( Rfc::XMLNode& nodeParent, Mode mode = modeFull ) const = 0;

//			static List fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db ) throw( Exception );
//			static List fromXML( const XMLNode& node ) throw( Exception );
	};
};

#endif /* !__Base_h__ */
