#ifndef __ContactType_h__
#define __ContactType_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>

#include <librfcdal/DalDatabase.h>
// #include <librfc/XMLNode.hpp>

#include <string>
#include <map>

namespace CADAData
{
//	const int nNotAContactTypeRow = 3001;
//	const int nNotAContactTypeNode = 3002;

	class CADAData_Export ContactType
	{
		private:
			int _nSeq;
			std::string _strContactType;
			std::string _strProtocol;
			std::string _strClassCSS;
			std::string _strTarget;

		public:
			ContactType();
			ContactType( const ContactType& contactType );
			virtual ~ContactType();

			const ContactType& operator=( const ContactType& contactType );

			int seq() const;
			const std::string& contactType() const;
			const std::string& protocol() const;
			const std::string& classCSS() const;
			const std::string& target() const;
			void setSeq( int nSeq );
			void setContactType( const std::string& strContactType );
			void setProtocol( const std::string& strProtocol );
			void setClassCC( const std::string& strClassCSS );
			void setTarget( const std::string& strTarget );

			void save( RfcDal::DalDatabase& db );
//			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
//			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static ContactType fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db ) throw( Exception );
// 			static ContactType fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};

	class CADAData_Export ContactTypeMap : public std::map<int, ContactType>
	{
		public:
			ContactTypeMap();
			ContactTypeMap( const ContactTypeMap& dealerContactS );
			virtual ~ContactTypeMap();

			const ContactTypeMap& operator=( const ContactTypeMap& dealerContactS );

//			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
//			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static ContactTypeMap fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db ) throw( Exception );
// 			static ContactTypeMap fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};
};

#endif /* !__ContactType_h__ */
