#ifndef __DealerContact_h__
#define __DealerContact_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>
#include <cadadata/ContactType.h>

#include <librfcdal/DalDatabase.h>
// #include <librfc/XMLNode.hpp>

#include <string>
#include <map>

namespace CADAData
{
//	const int nNotADealerContactRow = 1001;
//	const int nNotADealerContactNode = 1002;

	class CADAData_Export DealerContact
	{
		private:
			std::string _strDealer;
			const CADAData::ContactType* _ptype;
			std::string _strURL;

		public:
			DealerContact();
			DealerContact( const DealerContact& dealerContact );
			virtual ~DealerContact();

			const DealerContact& operator=( const DealerContact& dealer );

			const std::string& dealer() const;
			const CADAData::ContactType& contactType() const throw( CADAData::Exception );
			const std::string& url() const;
			void setDealer( const std::string& strDealer );
			void setContactType( const CADAData::ContactType& type );
			void setURL( const std::string& strURL );

			void save( RfcDal::DalDatabase& db );
// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static DealerContact fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db ) throw( Exception );
// 			static DealerContact fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};

	class CADAData_Export DealerContactMap : public std::map<int, DealerContact>
	{
		public:
			DealerContactMap();
			DealerContactMap( const DealerContactMap& dealerContactS );
			virtual ~DealerContactMap();

			const DealerContactMap& operator=( const DealerContactMap& dealerContactS );

// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static DealerContactMap fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db ) throw( Exception );
// 			static DealerContactMap fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};
};

#endif /* !__DealerContact_h__ */
