#ifndef __Gallery_h__
#define __Gallery_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>

#include <librfcdal/DalDatabase.h>
// #include <librfc/XMLNode.hpp>

#include <string>
#include <map>

namespace CADAData
{
	class Gallery;

	typedef std::map<std::string, Gallery*> GalleryPtrMap;

	class CADAData_Export Gallery
	{
		private:
			std::string _strGallery;
			std::string _strParentGallery;
			std::string _strName;
			GalleryPtrMap _children;

		public:
			Gallery();
			Gallery( const Gallery& gallery );
			virtual ~Gallery();

			const Gallery& operator=( const Gallery& gallery );

			const std::string& gallery() const;
			const std::string& parentGallery() const;
			const std::string& name() const;
			void setGallery( const std::string strGallery );
			void setParentGallery( const std::string strParentGallery );
			void setName( const std::string strName );
			GalleryPtrMap& children();

			void save( RfcDal::DalDatabase& db );
// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
// 			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static Gallery fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db ) throw( Exception );
// 			static Gallery fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};

	class CADAData_Export GalleryMap : public std::map<std::string, Gallery>
	{
		public:
			GalleryMap();
			GalleryMap( const GalleryMap& galleryS );
			virtual ~GalleryMap();

			const GalleryMap& operator=( const GalleryMap& galleryS );

// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
// 			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static GalleryMap fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db ) throw( Exception );
// 			static GalleryMap fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};
};

#endif /* !__Gallery_h__ */
