#ifndef __GalleryRoot_h__
#define __GalleryRoot_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>

#include <librfcdal/DalDatabase.h>
// #include <librfc/XMLNode.hpp>

#include <string>
#include <vector>
#include <map>

namespace CADAData
{
//	const int nNotAGalleryRootRow = 5001;
//	const int nNotAGalleryRootNode = 5002;

	class GalleryRoot;

	typedef std::map<std::string, GalleryRoot*> GalleryRootPtrMap;

	class CADAData_Export GalleryRoot
	{
		private:
			std::string _strGallery;
			std::string _strName;
			GalleryRootPtrMap _children;

		public:
			GalleryRoot();
			GalleryRoot( const GalleryRoot& gallery );
			virtual ~GalleryRoot();

			const GalleryRoot& operator=( const GalleryRoot& gallery );

			const std::string& gallery() const;
			const std::string& name() const;
			void setGallery( const std::string strGallery );
			void setName( const std::string strName );

			void save( RfcDal::DalDatabase& db );
// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
// 			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static GalleryRoot fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db ) throw( Exception );
// 			static GalleryRoot fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};

	class CADAData_Export GalleryRootMap : public std::map<std::string, GalleryRoot>
	{
		public:
			GalleryRootMap();
			GalleryRootMap( const GalleryRootMap& galleryS );
			virtual ~GalleryRootMap();

			const GalleryRootMap& operator=( const GalleryRootMap& galleryS );

// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
// 			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static GalleryRootMap fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db ) throw( Exception );
// 			static GalleryRootMap fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};
};

#endif /* !__GalleryRoot_h__ */
