#ifndef __NewsItem_h__
#define __NewsItem_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>

#include <librfcdal/DalDatabase.h>
// #include <librfc/XMLNode.hpp>

#include <string>
#include <vector>

namespace CADAData
{
	const int nNotANewsItemRow = 6001;
	const int nNotANewsItemNode = 6002;

	class CADAData_Export NewsItem
	{
		private:
			int _nNewsItem;
			std::string _strNewsDate;
			std::string _strTitle;
			std::string _strDescription;
			std::string _strURI;
			std::string _strURILegend;

		public:
			NewsItem();
			NewsItem( const NewsItem& newsItem );
			virtual ~NewsItem();

			const NewsItem& operator=( const NewsItem& newsItem );

			int newsItem() const;
			const std::string& newsDate() const;
			const std::string& title() const;
			const std::string& description() const;
			const std::string& uri() const;
			const std::string& uriLegend() const;
			void setNewsItem( int nEvent );
			void setNewsDate( const std::string strStartWhen );
			void setTitle( const std::string strTitle );
			void setDescription( const std::string strDescription );
			void setURI( const std::string strURI );
			void setURILegend( const std::string strURILegend );

			void save( RfcDal::DalDatabase& db );
// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
// 			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static NewsItem fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db ) throw( Exception );
// 			static NewsItem fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};

	class CADAData_Export NewsItemList : public std::vector<NewsItem>
	{
		public:
			NewsItemList();
			NewsItemList( const NewsItemList& newsItemS );
			virtual ~NewsItemList();

			const NewsItemList& operator=( const NewsItemList& newsItemS );

// 			void toXML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;
// 			void toXHTML( Rfc::XMLNode& nodeParent, bool bFull = true ) const;

			static NewsItemList fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db ) throw( Exception );
// 			static NewsItemList fromXML( const Rfc::XMLNode& node ) throw( Exception );
	};
};

#endif /* !__NewsItem_h__ */
