#ifndef __CADAData_Region_h__
#define __CADAData_Region_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>

#include <librfcdal/DalDatabase.h>
// #include <librfc/XMLNode.hpp>

#include <string>
#include <map>

namespace CADAData
{
	class CADAData_Export Region
	{
		private:
			std::string _strRegion;
			std::string _strParentRegion;
			std::string _strName;
			
		public:
			Region();
			Region( const Region& region );
			virtual ~Region();

			const Region& operator=( const Region& region );

			const std::string& region() const;
			const std::string& parentRegion() const;
			const std::string& name() const;

			void setRegion( const std::string& strRegion );
			void setParentRegion( const std::string& strParentRegion );
			void setName( const std::string& strName );

			void save( RfcDal::DalDatabase& db );

			static Region fromRow( const RfcDal::DalDatabase::Row& row, RfcDal::DalDatabase& db ) throw( Exception );
	};

	class CADAData_Export RegionMap : public std::map<std::string, Region>
	{
		public:
			static RegionMap fromResult( const RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& db ) throw( Exception );
	};

}

#endif /* !__CADAData_Region_h__ */
