#ifndef __StaticData_h__
#define __StaticData_h__

#include <cadadata/CADAData.h>
#include <cadadata/Exception.h>
#include <cadadata/DealerContact.h>
#include <cadadata/ContactType.h>
#include <cadadata/Dealer.h>
#include <cadadata/Day.h>
#include <cadadata/Status.h>
#include <cadadata/DealerHours.h>
#include <cadadata/Gallery.h>

#include <librfcdal/DalDatabase.h>
// #include <librfc/XMLNode.hpp>

#include <string>
#include <map>
#if (0)
namespace CADAData
{
	typedef std::map<int, ContactType> ContactTypeMap;
	typedef std::map<std::string, Dealer> DealerMap;
	typedef std::map<Day::EDay, Day> DayMap;
	typedef std::map<Status::EStatus, Status> StatusMap;
	typedef std::map<std::string, Gallery> GalleryMap;

	class CADAData_Export StaticData
	{
		private:
			static ContactTypeMap _contactTypeS;
			static DealerMap _dealerS;
			static DayMap _dayS;
			static StatusMap _statusS;
			static GalleryMap _galleryS;
			static GalleryPtrMap _galleryRootS;

		public:
			static void initialize();
			static const ContactTypeMap& contactTypes();
			static const DealerMap& dealers();
			static const DayMap& days();
			static const StatusMap& statuss();

		// features
			static void formatDealerContactXHTML( XMLNode& nodeParent, const DealerContact& dealerContact );
			static std::string dealerURI( const std::string strDealer );
			static void formatDealerXHTML( XMLNode& nodeParent, const std::string& strDealer );
			static void formatDealerHoursXHTML( XMLNode& nodeParent, const DealerHours& hours );
			static void formatGalleriesXHTML( XMLNode& nodeParent, const std::string& strTitleClass, const std::string& strLinkClass, GalleryPtrMap& galleryS = _galleryRootS );
	};
};
#endif
#endif /* !__StaticData_h__ */
