#ifndef ARTICLEWIDGET_H
#define ARTICLEWIDGET_H

#include <QMainWindow>

#include <cadadata/Article.h>

namespace Ui
{
	class ArticleWidget;
}

namespace CADAUIComponents
{
	class ArticleWidget : public QMainWindow
	{
			Q_OBJECT

		private:
			Ui::ArticleWidget* ui;
			CADAData::Article _articleNew;
			CADAData::Article* _particle;
			bool _bNew;

		public:
			explicit ArticleWidget( QWidget* pparent, int nNewArticleId );
			explicit ArticleWidget( QWidget* pparent, CADAData::Article& article );
			~ArticleWidget();

			void setup();

			CADAData::Article& article();

		private:
			void setArticle( CADAData::Article& articleReplace );

		protected slots:
			void onSave();
	};
}

#endif // ARTICLEWIDGET_H
