#ifndef DEALERCONTACTWIDGET_H
#define DEALERCONTACTWIDGET_H

#include <cadadata/Dealer.h>

#include <QWidget>

#include <map>

class QTreeWidgetItem;

namespace Ui
{
	class DealerContactWidget;
}

namespace CADAUIComponents
{
	class DealerContactTreeWidgetItem;

	class DealerContactWidget : public QWidget
	{
		Q_OBJECT

		private:
			Ui::DealerContactWidget *ui;
			CADAData::Dealer* _pdealer;
			DealerContactTreeWidgetItem* _pitemCurrent;
			CADAData::DealerContact* _pcontactCurrent;
			std::map<int, CADAData::Action> _actionS;

		public:
			explicit DealerContactWidget(QWidget *parent = 0);
			~DealerContactWidget();

			void setDealer( CADAData::Dealer& dealer );
			void save() throw( CADAData::Exception );

		protected slots:
			void onAdd();
			void onClickedContact( QTreeWidgetItem* pitem, int nCol );
			void onSave();
			void onDelete();
	};
}

#endif // DEALERCONTACTWIDGET_H
